
#pragma once
#include <stdio.h>
#include <windows.h>
#include "CurlingSimulator.h"
#include "Message.h"

#define PERMISSION_ID "Admin"
#define PERMISSION_PASS "imohit"
#define SERVER_ADMINISTRATOR ((struct UserList **)(LONG_PTR)-1)

extern SIMULATION_FUNC Simulation;
extern CREATESHOT_FUNC CreateShot;
extern CREATEHITSHOT_FUNC CreateHitShot;
extern GETSCORE_FUNC GetScore;
extern HMODULE hCSDLL;
extern bool g_EndFlg;

extern CRITICAL_SECTION cs;

#define NAME_SIZE 32
#define ID_SIZE 32
#define PASS_SIZE 16

#define DEFAULT_LASTEND 10
#define DEFAULT_TIME 438000

struct NetworkInfo
{
	SOCKET				socket;
	struct sockaddr_in	addr;
	int					addr_size;
};

typedef struct _GameStateEx{
	int		ShotNum;		// ݂̃Vbg
	// ShotNum  n ̏ꍇAɍsVbg n+1 ڂɂȂ

	int		CurEnd;			// ݂̃Gh
	int		LastEnd;		// ŏIGh
	int		Score[10];		// 1Gh10Gh܂ł̃XRA
	bool	WhiteToMove;	// Ԃ̏
	// WhiteToMove  0 ̏ꍇ̃Vbgŝ͐AWhiteToMove  1 ̏ꍇ̃Vbgŝ͌ƂȂ

	float	body[16][2];	// body[n]  n ڂ̃Xg[̈ʒuW\
	// body[n][0]  n ڂ̃Xg[ x WAbody[n][1]  n ڂ̃Xg[ y W\


	// g
	struct UserList	*First;
	struct UserList	*Second;
	DWORD		CreateTime;			// g񂾎
	float		Random;				// V~[VɈl
	char		LogFileName[1024];	// Ot@C

} GAMESTATEEX, *PGAMESTATEEX;

struct UserList
{
	char			id[ID_SIZE];				// ID
	bool			permission;					// ǗҌ
	char			password[PASS_SIZE];		// pX[h
	char			user_name[NAME_SIZE];		// [U[
	struct NetworkInfo	*network_info;			// lbg[N
	struct UserList		*next;

	struct _GameStateEx	*game_state;			// Q[

	unsigned long	starting_time;				// goR}h𑗂ꂽ
	unsigned long	remaining_time;				// 
	int				status;						// vC[
};

class cUserList
{
public:
	bool InitList();
	int DispUser(struct UserList *lpUser);
	UserList *AddUser(char *id, char *password, char *user_name, NetworkInfo *pNetworkInfo);
	bool ChangeState(char *id, char *state);
	bool DeleteUser(char *id);
	void LimitDecision();
	bool MatchMake(char *id1, char *id2, int last_end, unsigned long time1, unsigned long time2);
	int AutoMatchMake(int last_end, unsigned long time1, unsigned long time2);

	cUserList()
	{
		mList.next = nullptr;
	}

private:
	UserList mList;
};

extern class cUserList cUserList;

typedef struct _AutoMatch
{
	bool Status;
	DWORD Time;
	DWORD LastEnd;
	DWORD LastTime;
	DWORD AutoMatchCycle;
} AUTOMATCH, PAUTOMATCH;

typedef struct _System
{
	float				rand;
	struct _AutoMatch	AutoMatch;
} SYSTEM, *PSYSTEM;

extern struct _System System;

/* G[R[hꗗ */
enum
{
	NOT_ERR,		// G[Ȃ
	ERR_LOGINNG,
	ERR_DISCONNECT,
};

/* vC[̏ */
enum
{
	IN_WAIT			= 0x0001,		// ҋ@[h
	IN_PRE			= 0x0002,		// ΐ폀
	IN_READY		= 0x0004,		// ΐ폀
	IN_GAME			= 0x0008,		// ΐ풆
	IN_DISCONNECT	= 0x0010,	// ؒf
	PERMISSION	= 0x0020,		// Ǘ
	UNKNOWN			= 0x0040		// G[
};

void ReleaseGame(GAMESTATEEX *game_state);