
#include "System.h"

int cUserList::DispUser(UserList *lpUser)
{
	int iRet = 0;
	UserList *p;
	char buffer[1024];

	p = &mList;
	while (p->next != nullptr){
		p = p->next;
		sprintf_s(buffer, sizeof(buffer), "ID: %s\tUserName: %s\tSTATUS:", p->id, p->user_name);

		if (p->status & IN_WAIT){
			sprintf_s(buffer, sizeof(buffer), "%s: IN_WAIT", buffer);
		}
		if (p->status & IN_PRE){
			sprintf_s(buffer, sizeof(buffer), "%s: IN_PRE - %d", buffer, (6000 - (GetTickCount() - p->starting_time)) / 1000);
		}
		if (p->status & IN_READY){
			sprintf_s(buffer, sizeof(buffer), "%s: IN_READY", buffer);
		}
		if (p->status & IN_GAME){
			if ((p == p->game_state->First && p->game_state->WhiteToMove == 0)
				|| (p == p->game_state->Second && p->game_state->WhiteToMove == 1))
			{
				sprintf_s(buffer, sizeof(buffer), "%s: IN_GAME - %d", buffer, (p->remaining_time - (GetTickCount() - p->starting_time)) / 1000);
			}
			else{
				sprintf_s(buffer, sizeof(buffer), "%s: IN_GAME - %d", buffer, p->remaining_time / 1000);
			}
		}
		if (p->status & IN_DISCONNECT){
			sprintf_s(buffer, sizeof(buffer), "%s: IN_DISCONNECT", buffer);
		}
		if(p->status & PERMISSION){
			sprintf_s(buffer, sizeof(buffer), "%s: PERMISSION", buffer);
		}
		if (p->status & UNKNOWN){
			sprintf_s(buffer, sizeof(buffer), "%s: UNKNOWN", buffer);
		}

		// Ǘ([g)̏ꍇɂ́Asendŕ\e𑗂
		PrintMessage(lpUser, buffer);

		iRet++;
	}

	// Ǘ([g)̏ꍇɂ́Asendŕ\e𑗂
	sprintf_s(buffer, sizeof(buffer), "NCAgڑF%d", iRet);
	PrintMessage(lpUser, buffer);

	return iRet;
}

UserList *cUserList::AddUser(char *id, char *password, char *user_name, NetworkInfo *pNetworkInfo)
{
	UserList *pAdd = nullptr, *p;

	// o^OɊɃOCĂ邩mF
	p = &mList;
	while (p->next != nullptr){
		p = p->next;
		if (_stricmp(p->id, id) == 0){
			// ؒf̕A
			if (p->status & IN_DISCONNECT){
				p->status ^= IN_DISCONNECT;
				p->network_info->socket = 0x00;
				p->network_info = pNetworkInfo;

				SendGameState(p->game_state);
				if ((p == p->game_state->First && p->game_state->WhiteToMove == 0) || (p == p->game_state->Second && p->game_state->WhiteToMove == 1)){
					SendGoCommand(p->game_state);
				}

				return p;
			}
			return nullptr;
		}
	}

	// Xgɓo^
	pAdd = (UserList *)malloc(sizeof(UserList));
	if (pAdd != nullptr){
		strcpy_s(pAdd->id, sizeof(pAdd->id), id);

		// ǗҌ - ǗIDł́ApX[hԈĂꍇs
		if (_stricmp(id, PERMISSION_ID) == 0){
			if (_stricmp(password, PERMISSION_PASS) == 0){
				pAdd->permission = true;
				pAdd->status = PERMISSION;
			}
			else{
				return false;
			}
		}
		else{
			pAdd->permission = false;
			pAdd->status = IN_WAIT;
		}

		strcpy_s(pAdd->password, sizeof(pAdd->password), password);
		strcpy_s(pAdd->user_name, sizeof(pAdd->user_name), user_name);
		pAdd->network_info = pNetworkInfo;
		pAdd->next = nullptr;
		pAdd->game_state = nullptr;

		p->next = pAdd;
	}

	return pAdd;
}

bool cUserList::ChangeState(char *id, char *state)
{
	bool bRet = false;
	UserList *p, *q;

	q = &mList;
	p = q->next;

	while (p != nullptr){
		if (_stricmp(id, p->id) == 0){
			if (_stricmp(state, "IN_WAIT") == 0){
				p->status = IN_WAIT;
			}
			if (_stricmp(state, "IN_PRE") == 0){
				p->status = IN_PRE;
			}
			if (_stricmp(state, "IN_READY") == 0){
				p->status = IN_READY;
			}
			if (_stricmp(state, "IN_DISCONNECT") == 0){
				p->status = IN_DISCONNECT;
			}

			bRet = true;
			break;
		}
		q = p;
		p = p->next;
	}

	return bRet;
}

bool cUserList::DeleteUser(char *id)
{
	bool bRet = false;

	UserList *p, *q;
	q = &mList;
	p = q->next;

	while (p != nullptr){
		if (_stricmp(id, p->id) == 0){
			// T[o[IۂɃNCAgɏIbZ[W𑗂
			send(p->network_info->socket, "DISCONNECT\n", strlen("DISCONNECT\n") + 1, 0);

			// ΐ푊̏̕ύX
			if (p->game_state != nullptr && (p->status & (IN_GAME | IN_PRE | IN_READY))){
				if (p->status & IN_DISCONNECT){
					// ΐ풆łΑ̏Ƃ
					if (p->game_state->First == p){
						send(p->game_state->Second->network_info->socket, "GAMEOVER WIN\n", strlen("GAMEOVER WIN\n") + 1, 0);
					}
					else{
						send(p->game_state->First->network_info->socket, "GAMEOVER WIN\n", strlen("GAMEOVER WIN\n") + 1, 0);
					}
					ReleaseGame(p->game_state);
				}
				else{
					// ΐ풆łΐؒfԂƂAԂ؂ꂽ瑊̏Ƃ
					p->status |= IN_DISCONNECT;
				}
			}
			else{
				// XgΏۃvC[폜
				q->next = p->next;
				bRet = true;
			}

			break;
		}

		q = p;
		p = p->next;
	}

	return bRet;
}

// Ԑ؂Ή
void cUserList::LimitDecision()
{
	UserList *lpUser;
	char buffer[1024];

	for (lpUser = mList.next; lpUser != nullptr; lpUser = lpUser->next){
		if (lpUser->status & IN_GAME && lpUser->game_state != nullptr && ((lpUser == lpUser->game_state->First && lpUser->game_state->WhiteToMove == 0) || (lpUser == lpUser->game_state->Second && lpUser->game_state->WhiteToMove == 1)))
		{
			if (GetTickCount() - lpUser->starting_time > lpUser->remaining_time){
				GAMESTATEEX *game_state = lpUser->game_state;
				sprintf_s(buffer, sizeof(buffer), "TIMEOUT %s", lpUser->id);

				send(game_state->First->network_info->socket, buffer, strlen(buffer) + 1, 0);
				send(game_state->Second->network_info->socket, buffer, strlen(buffer) + 1, 0);

				// s̑M
				if (game_state->First == lpUser){
					send(game_state->First->network_info->socket, "GAMEOVER LOSE", strlen("GAMEOVER LOSE") + 1, 0);
					send(game_state->Second->network_info->socket, "GAMEOVER WIN", strlen("GAMEOVER WIN") + 1, 0);
				}
				else{
					send(game_state->First->network_info->socket, "GAMEOVER WIN", strlen("GAMEOVER WIN") + 1, 0);
					send(game_state->Second->network_info->socket, "GAMEOVER LOSE", strlen("GAMEOVER LOSE") + 1, 0);
				}

				// vC[̐ڑ؂Ă΃Xg珜O
				ReleaseGame(game_state);
				if (lpUser->status & IN_DISCONNECT){
					DeleteUser(lpUser->id);
				}
			}
		}
		else if (lpUser->status & (IN_PRE | IN_READY)){
			if (lpUser->game_state != nullptr){
				if (GetTickCount() - lpUser->game_state->CreateTime > 60000){
					GAMESTATEEX *game_state = lpUser->game_state;

					// vC[̐ڑ؂Ă΃Xg珜O
					ReleaseGame(game_state);
					if (lpUser->status & IN_DISCONNECT){
						DeleteUser(lpUser->id);
					}
				}
			}
		}
	}
}

// }b`CN
bool cUserList::MatchMake(char *id1, char *id2, int last_end, unsigned long time1, unsigned long time2)
{
	bool bRet = false;
	UserList *p, *user1 = nullptr, *user2 = nullptr;

	// 擾
	p = mList.next;
	while (p != nullptr){
		if (_stricmp(id1, p->id) == 0){
			user1 = p;
			break;
		}
		p = p->next;
	}

	// 擾
	p = mList.next;
	while (p != nullptr){
		if (_stricmp(id2, p->id) == 0){
			user2 = p;
			break;
		}
		p = p->next;
	}

	if (user1 != nullptr && user2 != nullptr
		&& user1->status == IN_WAIT && user2->status == IN_WAIT)
	{
		// Q[̐ݒ
		GAMESTATEEX *game_state = (GAMESTATEEX *)malloc(sizeof(GAMESTATEEX));

		// Q[̏
		game_state->CurEnd = 0;
		game_state->ShotNum = 0;
		game_state->WhiteToMove = 0;
		game_state->LastEnd = last_end;
		game_state->Random = System.rand;
		memset(game_state->Score, 0x00, sizeof(int)* 10);
		memset(game_state->body, 0x00, sizeof(float)* 32);

		// Ot@C
		FILE *fp;
		::SYSTEMTIME stTime;
		GetLocalTime(&stTime);
		sprintf_s(game_state->LogFileName, sizeof(game_state->LogFileName), ".\\Log\\%s - %s [%04d-%02d-%02d %02d%02d%02d].dcl", user1->id, user2->id, stTime.wYear, stTime.wMonth, stTime.wDay, stTime.wHour, stTime.wMinute, stTime.wSecond);
		if (fopen_s(&fp, game_state->LogFileName, "w+") != 0){
			CreateDirectory(".\\Log", nullptr);
			fopen_s(&fp, game_state->LogFileName, "w+");
		}

		if (fp != nullptr){
			fclose(fp);
		}

		// Q[̐ݒ
		user1->game_state = user2->game_state = game_state;

		// vC[Ԃ̕ύX
		user1->status = user2->status = IN_PRE;

		// vC[̎c莞Ԃ̐ݒ
		user1->remaining_time = time1;
		user2->remaining_time = time2;

		// ΐ푊̐ݒ
		game_state->First = user1;
		game_state->Second = user2;

		// ΐJn̍}
		send(game_state->First->network_info->socket, "ISREADY", strlen("ISREADY") + 1, 0);
		send(game_state->Second->network_info->socket, "ISREADY", strlen("ISREADY") + 1, 0);

		// ΐg񂾎擾
		game_state->CreateTime = GetTickCount();

		bRet = true;
	}

	return bRet;
}

// I[g}b`
int cUserList::AutoMatchMake(int last_end, unsigned long time1, unsigned long time2)
{
	int iRet = 0;

	int UserNum = 0;
	UserList *p, Users[1024];

	// ΐ\vC[̎擾
	for (p = mList.next; p != nullptr; p = p->next){
		if (p->status == IN_WAIT && p->permission == FALSE && p->status != IN_DISCONNECT){
			Users[UserNum] = *p;
			UserNum++;
		}
	}

	// ΐ\vC[̒烉_ɑΐg
	int RandomNumber;
	char id1[ID_SIZE], id2[ID_SIZE];

	srand(GetTickCount());
	while (UserNum >= 2){

		// 
		RandomNumber = rand() % UserNum;
		strcpy_s(id1, sizeof(id1), Users[RandomNumber].id);

		UserNum--;
		Users[RandomNumber] = Users[UserNum];

		// 
		RandomNumber = rand() % UserNum;
		strcpy_s(id2, sizeof(id2), Users[RandomNumber].id);

		UserNum--;
		Users[RandomNumber] = Users[UserNum];

		// }b`CN
		MatchMake(id1, id2, last_end, time1, time2);
		printf("\nMatchMake %s %s %d\n", id1, id2, last_end);

		iRet++;
	}

	if (iRet == 0){
		printf("AutoMatch : NonPlayer\n");
	}

	return iRet;
}