
#include "System.h"
#define MAX_THREAD_NUM 128
#define BUFFER_SIZE 1024

SIMULATION_FUNC Simulation = nullptr;
CREATESHOT_FUNC CreateShot = nullptr;
CREATEHITSHOT_FUNC CreateHitShot = nullptr;
GETSCORE_FUNC GetScore = nullptr;

HMODULE hCSDLL;
bool g_EndFlg = false;

class cUserList cUserList;
struct _System System;

CRITICAL_SECTION cs;

bool LoadFunction()
{
	hCSDLL = LoadLibrary("CurlingSimulator.dll");

	if (hCSDLL != nullptr){
		Simulation = (SIMULATION_FUNC)GetProcAddress(hCSDLL, "Simulation");
		CreateShot = (CREATESHOT_FUNC)GetProcAddress(hCSDLL, "CreateShot");
		CreateHitShot = (CREATEHITSHOT_FUNC)GetProcAddress(hCSDLL, "CreateHitShot");
		GetScore = (GETSCORE_FUNC)GetProcAddress(hCSDLL, "GetScore");
	}
	else{
		MessageBox(nullptr, "CurlingSimulator.dll ̓ǂݍ݂Ɏs܂", "G[", MB_OK);
		return false;
	}

	return true;
}

void ReleaseGame(GAMESTATEEX *game_state)
{
	// Q[̏I
	//--------------------------------------

	if (game_state != nullptr){
		// vC[Ԃ̕ύX
		game_state->First->status = (game_state->First->status & IN_DISCONNECT) | IN_WAIT;
		game_state->Second->status = (game_state->Second->status & IN_DISCONNECT) | IN_WAIT;

		// Q[̉
		game_state->First->game_state = nullptr;
		game_state->Second->game_state = nullptr;
		free(game_state);
	}
}

// s̍폜
void DeleteNL(char *msg)
{
	char *p;
	p = msg;

	while (*p != 0x00){
		if (*p == '\n'){
			*p = 0x00;
			break;
		}
		p++;
	}
	return;
}

DWORD WINAPI ResponseThread(LPVOID pParam)
{
	DWORD dwRet = true;
	char		msg[BUFFER_SIZE], Result[BUFFER_SIZE];
	NetworkInfo	*pNetworkInfo;
	int			recvSize;
	DWORD		err = NOT_ERR;
	UserList	*lpUser = nullptr;
	fd_set		fds, readfds;
	timeval		timeout;

	pNetworkInfo = (NetworkInfo *)pParam;
	send(pNetworkInfo->socket, "CONNECTED", strlen("CONNECTED") + 1, 0);

	// fd_set̏
	FD_ZERO(&readfds);

	// selectő҂ǂݍ݃\PbgƂsrcScoketo^
	FD_SET(pNetworkInfo->socket, &readfds);

	// ^CAEgԂ̐ݒ
	timeout.tv_sec = 1;
	timeout.tv_usec = 0;

	while (g_EndFlg != true && err == NOT_ERR){
		// ǂݍݗpfd_set̏
		memcpy(&fds, &readfds, sizeof(fd_set));

		// fdsɐݒ肳ꂽ\Pbgǂݍ݉\ɂȂ܂ő҂
		select(pNetworkInfo->socket + 1, &fds, nullptr, nullptr, &timeout);

		if (FD_ISSET(pNetworkInfo->socket, &fds)){
			// NeBJZNV
			EnterCriticalSection(&cs);

			// f[^̎M
			recvSize = recv(pNetworkInfo->socket, msg, sizeof(msg), 0);
			if (recvSize == SOCKET_ERROR || recvSize == 0){
				// NeBJZNV
				LeaveCriticalSection(&cs);

				// ؒfꂽꍇ
				if (recvSize == 0 || send(pNetworkInfo->socket, "", sizeof("") + 1, 0) == SOCKET_ERROR){
					// I
					cUserList.DeleteUser(lpUser->id);
					break;
				}
				continue;
			}

			DeleteNL(msg);
			DoCommand(msg, &lpUser, &err, Result, pNetworkInfo);

			// NeBJZNV
			LeaveCriticalSection(&cs);
		}
	}

	return dwRet;
}

void WINAPI NetworkThread(LPVOID pParam)
{
	// |[gԍA\Pbg
	unsigned short *port;
	port = (unsigned short *)(pParam);
	SOCKET srcSocket;
	NetworkInfo NetworkInfo[MAX_THREAD_NUM];
	memset(NetworkInfo, 0x00, sizeof(NetworkInfo));
	for (int i = 0; i<MAX_THREAD_NUM; i++){
		NetworkInfo[i].addr_size = sizeof(struct sockaddr_in);
	}

	// sockaddr_in \
	struct sockaddr_in srcAddr;

	// ep[^
	HANDLE	hThread[304] = {};
	DWORD	dwThreadId;
	int		thread_num;
	fd_set	fds, readfds;
	timeval timeout;

	/************************************************************/
	/* Windows Ǝ̐ݒ */
	WSADATA data;
	WSAStartup(MAKEWORD(2, 0), &data);

	// sockaddr_in \̂̃Zbg
	memset(&srcAddr, 0, sizeof(srcAddr));
	srcAddr.sin_port = htons(*port);
	srcAddr.sin_family = AF_INET;
	srcAddr.sin_addr.s_addr = htonl(INADDR_ANY);

	// \Pbg̐
	srcSocket = socket(AF_INET, SOCK_STREAM, 0);

	// \Pbg̃oCh
	int i = bind(srcSocket, (struct sockaddr *) &srcAddr, sizeof(srcAddr));

	// ڑ̋
	i = listen(srcSocket, 1);

	// fd_set̏
	FD_ZERO(&readfds);

	// selectő҂ǂݍ݃\PbgƂsrcScoketo^
	FD_SET(srcSocket, &readfds);

	// ^CAEgԂ̐ݒ
	timeout.tv_sec = 1;
	timeout.tv_usec = 0;

	// pPbgM
	for (thread_num = 0; g_EndFlg != true; thread_num++){
		if (thread_num >= MAX_THREAD_NUM) thread_num = 0;
		if (NetworkInfo[thread_num].socket != 0) continue;

		while (g_EndFlg != true){
			// ǂݍݗpfd_set̏
			memcpy(&fds, &readfds, sizeof(fd_set));

			// fdsɐݒ肳ꂽ\Pbgǂݍ݉\ɂȂ܂ő҂
			select(srcSocket + 1, &fds, nullptr, nullptr, &timeout);

			// ڑ̎t
			if (FD_ISSET(srcSocket, &fds)){
				NetworkInfo[thread_num].socket = accept(srcSocket, (struct sockaddr *) &NetworkInfo[thread_num].addr, &NetworkInfo[thread_num].addr_size);
				hThread[thread_num] = CreateThread(nullptr, 0, (LPTHREAD_START_ROUTINE)ResponseThread, &NetworkInfo[thread_num], 0, &dwThreadId);

				break;
			}
		}
	}
	WaitForMultipleObjects(thread_num, hThread, true, INFINITE);
	WSACleanup();
}

void AutoMatchThread(LPVOID pParam)
{
	DWORD CurrentTime;
	System.AutoMatch.LastEnd = DEFAULT_LASTEND;		// ŏIGh
	System.AutoMatch.Time = DEFAULT_TIME;		//  - 7.3(438b)

	while (g_EndFlg != TRUE){
		if (System.AutoMatch.Status == TRUE){
			if (( CurrentTime = GetTickCount() ) > System.AutoMatch.LastTime + System.AutoMatch.AutoMatchCycle){
				// NeBJZNV
				EnterCriticalSection(&cs);

				cUserList.AutoMatchMake(System.AutoMatch.LastEnd, System.AutoMatch.Time, System.AutoMatch.Time);
				System.AutoMatch.LastTime = CurrentTime;

				// NeBJZNV
				LeaveCriticalSection(&cs);
			}
		}
		Sleep(1);
	}
}

void LimitThread(LPVOID pParam)
{
	while (g_EndFlg != TRUE){
		// NeBJZNV
		EnterCriticalSection(&cs);

		cUserList.LimitDecision();

		// NeBJZNV
		LeaveCriticalSection(&cs);

		Sleep(1);
	}
}

int main()
{
	bool bRet = false;
	DWORD dwThreadId, err;
	HANDLE hThread[3];

	// ֐̓ǂݍ
	if (LoadFunction() != true){
		return bRet;
	}

	// NeBJZNV쐬
	InitializeCriticalSection(&cs);

	// T[o[̏
	System.rand = 0.145f;

	// T[o[N
	unsigned short port = 9876;
	hThread[0] = CreateThread(nullptr, 0, (LPTHREAD_START_ROUTINE)NetworkThread, &port, 0, &dwThreadId);
	if (hThread[0] != nullptr){
		bRet = true;
	}

	// I[g}b`Xbh
	hThread[1] = CreateThread(nullptr, 0, (LPTHREAD_START_ROUTINE)AutoMatchThread, nullptr, 0, &dwThreadId);
	if (hThread[1] != nullptr){
		bRet = true;
	}

	// Ԑ؂ꔻpXbh
	hThread[2] = CreateThread(nullptr, 0, (LPTHREAD_START_ROUTINE)LimitThread, nullptr, 0, &dwThreadId);
	if (hThread[2] != nullptr){
		bRet = true;
	}

	// R}h̓ǂݍ
	char msg[BUFFER_SIZE], Result[BUFFER_SIZE];
	printf("Server>");
	while (g_EndFlg != true){
		gets_s(msg, sizeof(msg));		// R}h̎擾
		DeleteNL(msg);					// s̍폜

		// NeBJZNV
		EnterCriticalSection(&cs);

		DoCommand(msg, SERVER_ADMINISTRATOR, &err, Result, nullptr);

		// NeBJZNV
		LeaveCriticalSection(&cs);
	}
	WaitForSingleObject(hThread, INFINITE);

	// NeBJZNV̔j
	DeleteCriticalSection(&cs);

	return bRet;
}